package polyglot.ext.ejava.ast;

import polyglot.ast.JL;
import polyglot.ast.Node;
import polyglot.ext.ejava.types.EJavaContext;
import polyglot.ext.ejava.types.ExtensionType;
import polyglot.ext.jl.ast.JL_c;
import polyglot.ext.jl5.ast.JL5FieldDecl;
import polyglot.types.SemanticException;
import polyglot.visit.TypeChecker;

public class EJavaFieldDecl_Del extends JL_c implements JL {

    @Override
    public Node typeCheck(TypeChecker tc) throws SemanticException {
        ExtensionType et = ((EJavaContext) tc.context()).currentExtension();
        JL5FieldDecl fd = (JL5FieldDecl) node();
        if (et != null) {
            if (!et.isTop())
                throw new SemanticException(
                        "only top-level expander declarations can declare fields");
            if (fd.init() == null)
                throw new SemanticException(
                        "expander fields must be initialized at declaration time");

            // Not sure if I really need to do the following, but I'm doing it
            // anyway (can't hurt...)
            ExtensionType top = null;
            try {
                top = (ExtensionType) tc.context().importTable().find(et.extensionName());
            } catch (SemanticException e) {
                throw new SemanticException("extension type " + et.extensionName() + " not found");
            } catch (ClassCastException e) {
                throw new SemanticException(et.extensionName() + " is not an extension type");
            }
        }
        return fd.typeCheck(tc);
    }

}
