package polyglot.ext.ejava.ast;

import java.util.List;

import polyglot.ast.*;
import polyglot.ext.jl5.ast.JL5NodeFactory;
import polyglot.ext.jl5.types.FlagAnnotations;
import polyglot.util.Position;

/**
 * NodeFactory for ejava extension.
 */
public interface EJavaNodeFactory extends JL5NodeFactory {

    ExtensionDecl ExtensionDecl(Position pos, FlagAnnotations flags, String name, TypeNode forClass,
            List interfaces, ClassBody body, boolean isTop);

    ExtensionApplication ExtensionApplication(Position pos, Expr expr, TypeNode ext,
            boolean augmented);

    Unextended Unextended(Position pos, Expr expr);
    
    UseExpander UseExpander(Position pos, Import.Kind kind, String name);

    public static final Special.Kind UNEXTENDED = new Special.Kind("instance");
}
