package polyglot.ext.ejava.ast;

import java.util.List;

import polyglot.ast.*;
import polyglot.ast.Import.Kind;
import polyglot.ext.jl5.ast.JL5Call;
import polyglot.ext.jl5.ast.JL5Field;
import polyglot.ext.jl5.ast.JL5FieldDecl;
import polyglot.ext.jl5.ast.JL5MethodDecl;
import polyglot.ext.jl5.ast.JL5NodeFactory_c;
import polyglot.ext.jl5.types.FlagAnnotations;
import polyglot.util.Position;

/**
 * NodeFactory for ejava extension.
 */
public class EJavaNodeFactory_c extends JL5NodeFactory_c implements EJavaNodeFactory {
    public ExtensionDecl ExtensionDecl(Position pos, FlagAnnotations flags, String name, TypeNode forClass,
            List interfaces, ClassBody body, boolean isTop) {
        return new ExtensionDecl_c(pos, flags, name, forClass, interfaces, body, isTop);
    }

    public ExtensionApplication ExtensionApplication(Position pos, Expr expr, TypeNode ext,
            boolean augmented) {
        return new ExtensionApplication_c(pos, expr, ext, augmented);
    }

    public Unextended Unextended(Position pos, Expr expr) {
        return new Unextended_c(pos, expr);
    }

    public UseExpander UseExpander(Position pos, Kind kind, String name) {
        return new UseExpander_c(pos, kind, name);
    }

    @Override
    public Special Special(Position pos, polyglot.ast.Special.Kind kind, TypeNode outer) {
        return (Special) super.Special(pos, kind, outer).del(new EJavaSpecial_Del());
    }

    @Override
    public JL5Field JL5Field(Position pos, Receiver target, String name) {
        return (JL5Field) super.JL5Field(pos, target, name).del(new EJavaField_Del());
    }

    @Override
    public JL5FieldDecl JL5FieldDecl(Position pos, FlagAnnotations flags, TypeNode type, String name, Expr init) {
        return (JL5FieldDecl) super.JL5FieldDecl(pos, flags, type, name, init).del(new EJavaFieldDecl_Del());
    }

    @Override
    public polyglot.ext.jl5.ast.JL5Call JL5Call(Position pos, Receiver target, String name, List args, List typeArgs) {
        return (JL5Call) super.JL5Call(pos, target, name, args, typeArgs).del(new EJavaCall_Del());
    }

    @Override
    public polyglot.ext.jl5.ast.JL5MethodDecl JL5MethodDecl(Position pos, FlagAnnotations flags, TypeNode returnType, String name, List formals, List throwTypes, polyglot.ast.Block body, List typeParams) {
        return (JL5MethodDecl) super.JL5MethodDecl(pos, flags, returnType, name, formals, throwTypes, body, typeParams).
            del(new EJavaMethodDecl_Del());
    }

    
}
