package polyglot.ext.ejava.ast;

import java.util.List;

import polyglot.ast.Expr;
import polyglot.ast.Node;
import polyglot.ast.Term;
import polyglot.ext.ejava.types.EJavaTypeSystem;
import polyglot.ext.jl.ast.Expr_c;
import polyglot.types.ClassType;
import polyglot.types.SemanticException;
import polyglot.util.CodeWriter;
import polyglot.util.Position;
import polyglot.visit.CFGBuilder;
import polyglot.visit.NodeVisitor;
import polyglot.visit.PrettyPrinter;
import polyglot.visit.TypeChecker;

public class Unextended_c extends Expr_c implements Unextended {
    protected Expr expression;

    public Unextended_c(Position pos, Expr expression) {
        super(pos);
        this.expression = expression;
    }

    public Expr expression() {
        return expression;
    }

    public Unextended expression(Expr expression) {
        Unextended_c r = (Unextended_c) copy();
        r.expression = expression;
        return r;
    }

    public void prettyPrint(CodeWriter w, PrettyPrinter pp) {
        expression().prettyPrint(w, pp);
    }

    public Node typeCheck(TypeChecker tc) throws SemanticException {
        return type(((EJavaTypeSystem) tc.typeSystem()).UnextendedType((ClassType) expression()
                .type()));
    }

    public Node visitChildren(NodeVisitor v) {
        return expression((Expr) visitChild(expression, v));
    }

    public Term entry() {
        return expression().entry();
    }

    public List acceptCFG(CFGBuilder v, List succs) {
        v.visitCFG(expression, this);
        return succs;
    }

    public String toString() {
        return expression().toString();
    }
}
