package polyglot.ext.ejava.visit;

import polyglot.ast.Node;
import polyglot.ast.NodeFactory;
import polyglot.ext.ejava.types.EJavaContext;
import polyglot.ext.ejava.types.EJavaTypeSystem;
import polyglot.frontend.Job;
import polyglot.types.SemanticException;
import polyglot.types.TypeSystem;
import polyglot.visit.NodeVisitor;
import polyglot.visit.TypeChecker;

public class EJavaTypeChecker extends TypeChecker {

    public EJavaTypeChecker(Job job, TypeSystem ts, NodeFactory nf) {
        super(job, ts, nf);
    }

    
    @Override
    public NodeVisitor begin() {
        ((EJavaTypeSystem)typeSystem()).setUseExpanders(true);
        return super.begin();
    }


    @Override
    public void finish() {
        super.finish();
        ((EJavaTypeSystem)typeSystem()).setUseExpanders(false);
    }


    @Override
    protected NodeVisitor enterCall(Node parent, Node n) throws SemanticException {
        ((EJavaTypeSystem)typeSystem()).setCurrentContext((EJavaContext) context());
        return super.enterCall(parent, n);
    }

    @Override
    protected Node leaveCall(Node old, Node n, NodeVisitor v) throws SemanticException {
        ((EJavaTypeSystem)typeSystem()).setCurrentContext((EJavaContext) context());
        ((EJavaTypeSystem)typeSystem()).setUseExpanders(true);
        Node r = super.leaveCall(old, n, v);
        ((EJavaTypeSystem)typeSystem()).setUseExpanders(false);
        return r;
    }
    
    

}
