package polyglot.ext.ejava.visit;

import polyglot.ast.Node;
import polyglot.ast.NodeFactory;
import polyglot.ext.ejava.ast.ExtensionDecl;
import polyglot.frontend.Job;
import polyglot.types.SemanticException;
import polyglot.types.TypeSystem;
import polyglot.visit.ContextVisitor;

public class ExtensionCaseClearer extends ContextVisitor {
  public ExtensionCaseClearer(Job job, TypeSystem ts, NodeFactory nf) {
    super(job, ts, nf);
  }

  protected Node leaveCall(Node n) throws SemanticException {
      if (n instanceof ExtensionDecl) {
        ExtensionDecl nn = (ExtensionDecl) n;
        nn.clearCases();
        return nn;
    }
    return super.leaveCall(n);
  }
}
