package polyglot.ext.ejava.visit;

import java.util.HashMap;

import polyglot.ast.Node;
import polyglot.ast.NodeFactory;
import polyglot.ext.ejava.ast.ExtensionDecl;
import polyglot.frontend.Job;
import polyglot.types.SemanticException;
import polyglot.types.TypeSystem;
import polyglot.visit.ContextVisitor;

/*******************************************************************************
 * Visitor that adds all of the cases of an extension to the top-level
 * extension. This guy side-effects ExtensionDecl ast nodes.
 ******************************************************************************/
public class TopLevelExtensionGatherer extends ContextVisitor {
    protected HashMap extensions;

    public TopLevelExtensionGatherer(Job job, TypeSystem ts, NodeFactory nf, HashMap extensions) {
        super(job, ts, nf);
        this.extensions = extensions;
    }

    protected Node leaveCall(Node n) throws SemanticException {
        if (n instanceof ExtensionDecl) {
            ExtensionDecl nn = (ExtensionDecl) n;

            if (nn.isTop()) {
                String compilationUnit = n.position().file();
                if (context.package_() != null)
                    compilationUnit = context.package_() + "." + compilationUnit;
                HashMap extensionsInThisCU = (HashMap) extensions.get(compilationUnit);
                if (extensionsInThisCU == null) {
                    extensionsInThisCU = new HashMap();
                    extensions.put(compilationUnit, extensionsInThisCU);
                }
                if (extensionsInThisCU.put(nn.name(), nn) != null) {
                    System.out.println("internal compiler error 1!!!");
                    System.exit(1);
                }
            }
            return n;
        }
        return super.leaveCall(n);
    }
}
